function IntegrationSafraPay(PaymentRepository, ScreenService, WindowService, templateManager){

    var self = this;
    var PAYMENT_CONFIRMATION = false;
    var REMOVE_ALL_INTEGRATIONS = false;
    var MESSAGE_INTEGRATION_FAIL = 'Não foi possível chamar a integração. Sua instância não existe.';

    this.getPaymentInvoice = function(){
        var now = new Date();
        var year = now.getFullYear().toString();
        var month = self.leftZero(now.getMonth() + 1);
        var day = self.leftZero(now.getDate());
        var hour = self.leftZero(now.getHours());
        var minutes = self.leftZero(now.getMinutes());
        var seconds = self.leftZero(now.getSeconds());
        return year + month + day + hour + minutes + seconds;
    };

    this.integrationPayment = function(operatorData, currentRow){
        var params = {
            'paymentType': currentRow.tiporece.IDTIPORECE,
            'paymentValue': (currentRow.VRMOVIVEND.toFixed(2))*1000/10,//Favor não alterar, bug com 55 centavos
            'installmentsNumber': 0,
            'SafraPayId': self.getPaymentInvoice()
        };

        if(!!window.zhSafraPayAutomation) {
            zhSafraPayAutomation.initiateApp();
            zhSafraPayAutomation.continueApplication(JSON.stringify(params));
        } else {
            window.returnIntegration(self.invalidIntegrationInstance());
        }
    };

    this.leftZero = function(leftZero){
        if(leftZero < 10)
            leftZero = "0" + leftZero;

        return leftZero;
    };

    this.integrationPaymentResult = function(resolve, javaResult){
        var integrationResult = self.formatResponde();
        javaResult = self.handleJavaResult(javaResult);
        ScreenService.closePopup();
        if (javaResult.Status == 1){
                integrationResult.error = false;
                integrationResult.data = {
                    CDNSUHOSTTEF: javaResult.NsuTransacao,
                    TRANSACTIONID: javaResult.SafraPayId,
                    NRCONTROLTEF: javaResult.SafraPayId,
                    CDBANCARTCR: javaResult.Bandeira,
                    PAYMENTCONFIRMATION: PAYMENT_CONFIRMATION,
                    REMOVEALLINTEGRATIONS: REMOVE_ALL_INTEGRATIONS
                };
                ScreenService.restoreDefaultLoadingMessage();
                resolve(integrationResult);
        } else {
            integrationResult.message = javaResult.message||"Falha ao verificar retorno da transação";
            ScreenService.restoreDefaultLoadingMessage();
            resolve(integrationResult);
        }
    };

    // o cancelamento da SafraPay é o próprio estorno
    this.cancelIntegration = function(tiporeceData){
        self.reversalIntegration(tiporeceData);
    };

    this.cancelIntegrationResult = function(resolve, javaResult){
        self.reversalIntegrationResult(resolve, javaResult);
    };

    this.reversalIntegration = function(tiporeceData){
        if(!!window.zhSafraPayAutomation) {
            zhSafraPayAutomation.initiateApp();
            zhSafraPayAutomation.cancelaTransacao(tiporeceData.TRANSACTIONID, (tiporeceData.CDNSUHOSTTEF||null) );
        } else {
            window.returnIntegration(self.invalidIntegrationInstance());
        }
    };

    this.reversalIntegrationResult = function(resolve, javaResult){
        var integrationResult = self.formatResponde();

        if (javaResult.statusCode == 1 || javaResult.statusCode == 3 ){
            integrationResult.error = false;
            resolve(integrationResult);
        } else {
            integrationResult.message = javaResult.message;
            resolve(integrationResult);
        }
    };

    this.completeIntegration = function(){
        return true;
    };

    this.completeIntegrationResult = function(resolve, javaResult){
        return true;
    };

    this.formatResponde = function(){
        return {
            error: true,
            message: '',
            data: {}
        };
    };

    this.invalidIntegrationInstance = function(){
        return {
            statusCode: '2',
            message: MESSAGE_INTEGRATION_FAIL
        };
    };

    this.handleJavaResult = function(javaResult){
        if(typeof(javaResult) === 'string'){
            javaResult = JSON.parse(javaResult);
        }
        return javaResult;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IntegrationSafraPay', IntegrationSafraPay);
});