function PrinterPositivo(ScreenService){

	var self = this;

	var INVALID_PRINTER_INSTANCE = 'Não foi possível chamar a impressora. Sua instância não existe.';

	this.print = function(){
		if (window.ZhPositivoPrinter){
			window.ZhPositivoPrinter.AbreConexaoImpressora();
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.abrePorta = function(){
		if (window.ZhPositivoPrinter){
			window.ZhPositivoPrinter.AbreConexaoImpressora();
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.corteParcial = function(){
		if (window.ZhPositivoPrinter){
			window.ZhPositivoPrinter.Corte(10);
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printText = function(text){
		if (window.ZhPositivoPrinter){
			window.ZhPositivoPrinter.ImpressaoTexto(text,0,0,0);
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printQRCode = function(qrCode){
		if (window.ZhPositivoPrinter){
			window.ZhPositivoPrinter.ImpressaoQRCode(qrCode,4,4);
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printBarCode = function(barCode){
		if (window.ZhPositivoPrinter){
			window.ZhPositivoPrinter.ImpressaoCodigoBarras(8,"{C"+barCode, 60, 4 ,4);
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printerDelay = function(time){
		setTimeout(function(){
			var returnObj = self.formatResponse();
			returnObj.error = false;
			window.returnPrintResult(JSON.stringify(returnObj));
		}.bind(this), parseInt(time));	
	};

	this.reprintTEFVoucher = function(){
		window.returnIntegration = _.bind(self.getReprintTextResult, this);

		if (!!window.ZhPositivoPrinter){
			ZhPositivoPrinter.showAdministrativeMenu();
		} else {
			window.returnIntegration(self.invalidPrinterInstance());
		}
	};

	this.getReprintTextResult = function(javaResult){
		window.returnPrintResult = _.bind(self.reprintResult, this);
		if(typeof(javaResult) === 'string') {
			javaResult = JSON.parse(javaResult);
		}
		var comandos = [javaResult.customerReceipt, "", ""];

		if(javaResult.paymentTransactionStatus === 0) {
			comandos.forEach(function(text) {
				self.printText(text);
			}.bind(this));
		} else {
			ScreenService.showMessage("Erro ao tentar encontrar o último comprovante TEF");
		}
	};

	this.reprintResult = function (javaResult) {
		if(typeof(javaResult) === 'string') {
			javaResult = JSON.parse(javaResult);
		}

		if(javaResult.paymentTransactionStatus === 1) {
			ScreenService.showMessage("Erro ao imprimir o último comprovante TEF");
		}
	};

	this.printResult = function(resolve, javaResult){
		/*
		var response = self.formatResponse();
		if((javaResult.status||'1') !== "0"){
			javaResult.error = true;
			javaResult.message = javaResult.message||"Ocorreu um erro ao realizar a impressão";
		}
		*/
		resolve(javaResult);
	};

	this.invalidPrinterInstance = function(){
		return JSON.stringify({
            'error': true,
            'message': INVALID_PRINTER_INSTANCE
        });
	};
	
	this.validPrinterResult = function(result){
	    if( result < 0 ){
            return { 'error': true, 'message': ("Erro ao executar função de impressão. "+result) };
	    } else {
            return { 'error': false, 'message': false };
	    }
    };

	this.formatResponse = null;
}

Configuration(function(ContextRegister) {
	ContextRegister.register('PrinterPositivo', PrinterPositivo);
});